
function dbg(txt) {
	document.getElementById("dbg").innerHTML = txt;
}

function level_changed(e) {
	var key = e.keyCode;
	if (key == 13)
		start();
}

function reset() {
	// reset all levels
	var e;
	for (i = 0; i <= 4 ;i++) {
		for (j = 1; j < 20;j++) {
			e = document.getElementById("lv_" + i + "_" + j);
			if (e)
				set_current(i + "_" + j, 0);
			else
				break;
		}
	}
	// check current level
	var base_lv = get_base_level();
	if ((! base_lv) || (base_lv < 0))
		set_base_level(1);
	set_current("0_1", 1);
}

function level_move(n) {
	var item;
	if (n > 0) {
		item = document.getElementById("lv_l");
		item.value = item.value + 10;
	} else {
		item = document.getElementById("lv_l");
		item.value = item.value + 1;
	}
}

function get_base_level() {
	return parseInt(document.getElementById("level").value);
}

function set_base_level(n) {
	document.getElementById("level").value = n;
}

function start() {
	reset();
	change_base_level();
}

function change_base_level() {
	var lv = get_base_level();
	if (lv > 0) {
		document.getElementById("base_point").innerHTML = lv;
		document.getElementById("point").innerHTML = lv -1;
	}
}

// mouse events
function on_mouse(id) {
	//var div = document.getElementById("description");
	//div.innerHTML = d;
	change_description(id, 1);
	//div.style.visibility = "visible";
}

function out_mouse(id) {
	//var div = document.getElementById("description");
	//div.style.visibility = "hidden";
	change_description(id, 0);
}

function get_value(id) {
	return document.getElementById(id).innerHTML;
}

function set_value(id, txt) {
	document.getElementById(id).innerHTML = txt;
}

/* get values */

function get_point_remained() {
	return get_value("point");
}

function set_point_remained(n) {
	set_value("point", n);
}

function change_point_remained(n) {
	var m = parseInt(get_value("point")) + parseInt(n);
	set_point_remained(m);
}

/* get values of current item */

function get_current(id) {
	return parseInt(document.getElementById("lv_" + id).innerHTML);
}

function set_current(id, n) {
	document.getElementById("lv_" + id).innerHTML = n;
}

function get_max(id) {
	return parseInt(document.getElementById("mlv_" + id).innerHTML);
}

function is_max(id, n) {
	var m = get_max(id);
	return n > m;
}

// skill data -----

function get_skill_data(id) {
	// get skill data by id
	// data format: premise skill;depended skills;level limitations
	// items are separated by comma if some elements are there
	
	return get_value("data_" + id);
}

function get_skill_data_promise(id) {
	// returns premise skill id
	var data = get_skill_data(id);
	
	var d = data.split(";");
	if (d.length >= 1)
		return d[0];
	else
		return "";
}

function get_skill_data_depends(id) {
	// returns depended skill ids
	var data = get_skill_data(id);
	var d = data.split(";");
	
	if (d.length >= 2)
		return d[1].split(",");
	else
		return new Array();
}

function get_skill_data_levels(id) {
	// returns skill levels
	var data = get_skill_data(id);
	var d = data.split(";");
	if (d.length >= 3)
		return d[2].split(",");
	else
		return new Array()
}


function check_skill_level(id, lv) {
	var base_level = get_base_level();
	var lvs = get_skill_data_levels(id);
	return (lvs[lv -1] <= base_level);
}


function is_lv_up(id, n_lv) {
	// check premise skill and level
	
	// check promise one
	var p_id = get_skill_data_promise(id);
	
	if (p_id != "") {
		if (get_current(p_id) <= 0)
			return false;
	}
	
	// check level limitation
	if (check_skill_level(id, n_lv))
		return true;
	else
		return false;
}

function is_lv_down(id, n_lv) {
	// check depended skill
	if (n_lv > 0)
		return true;
	
	var d_ids = get_skill_data_depends(id);
	var v = true;
	
	for (i = 0;i < d_ids.length;i++) {
		if (get_current(d_ids[i]) > 0) {
			v = false;
			break;
		}
	}
	return v;
}

function lv_up(id, n) {
	var c = get_current(id); // current skill level
	var m = get_max(id); // max level
	var a = 0; // changes
	
	if ((n > 0) && (c < m)) {
		if (get_point_remained() <= 0)
			return false;
		
		if (is_max(id, c + n))
			return false;
		
		if (is_lv_up(id, c + n)) {
			set_current(id, c + n);
			a = n;
		}
	}
	
	if ((n < 0) && (c + n >= 0)) {
		if (is_lv_down(id, c + n)) {
			set_current(id, c + n);
			a = n;
		}
	}
	
	if (a != 0)
		change_point_remained(-n);
}


function dbg_click() {
	dbg(get_data("0_1"));
}


function get_description(id, lv) {
	return document.getElementById(id + "_" + lv);
}

function show_description(id, lv) {
	var d = get_description(id, lv);
	d.style.visibility = "visible";
}

function hide_description(id, lv) {
	var d = get_description(id, lv);
	d.style.visibility = "hidden";
}

function hide_all_descriptions() {
	var es = document.getElementsByTagName("skill_data");
	for (i = 0; i < es.length; i++) {
		es[i].style.visibility = "hidden";
	}
}

function get_description_content(id, lv) {
	return get_description(id, lv).innerHTML;
}

function get_description_div(n) {
	return document.getElementById("description_" + n);
}

function change_description_visibility(id, lv, vis, dno) {
	var d = get_description_div(dno);
	d.style.visibility = vis;
	if (vis == "visible") {
		//d.style.height = "auto";
		var t = get_description_content(id, lv);
		d.innerHTML = t;
	} else {
		//d.style.height = "0px";
		d.innerHTML = "";
	}
}

function move_descriptions(id) {
	var item = document.getElementById("item_" + id);
	var d = document.getElementById("descriptions");
	d.style.left = item.style.left;
	d.style.top = item.style.top;
}

function change_description(id, show) {
	// show current and next. zero: show lv 1 and max: show max lv
	var c = get_current(id);
	var m = get_max(id);
	var s;
	if (show == 1)
		s = "visible";
	else
		s = "hidden";
	
	if (c == 0) {
		change_description_visibility(id, 1, s, 1);
	}
	else if (c == m) {
		change_description_visibility(id, m, s, 1)
	}
	else {
		change_description_visibility(id, c, s, 1);
		change_description_visibility(id, c +1, s, 2);
	}
	
	move_descriptions(id);
}


